From f343b81dd46fc6cba00b95a1ebd547909ac8a08f Mon Sep 17 00:00:00 2001
From: lijianguo <lijianguo1991@outlook.com>
Date: Wed, 5 Mar 2025 17:19:27 +0800
Subject: [PATCH 1/3] chore(builds): modify secondary confirmation info

---
 cmd/builds.go      | 2 +-
 cmd/builds_test.go | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

diff --git a/cmd/builds.go b/cmd/builds.go
index f023a738..3222070a 100644
--- a/cmd/builds.go
+++ b/cmd/builds.go
@@ -230,7 +230,7 @@ func buildFetchConfirmAction(confirm, procfile, dryccpath string, save bool) err
 		fmt.Print(msg)
 		fmt.Scanln(&confirm)
 		if confirm != "yes" {
-			return fmt.Errorf("cancel the build create fetch")
+			return fmt.Errorf("cancel the build fetch action")
 		}
 	}
 	return nil
diff --git a/cmd/builds_test.go b/cmd/builds_test.go
index 47c218e3..dc00763c 100644
--- a/cmd/builds_test.go
+++ b/cmd/builds_test.go
@@ -320,7 +320,7 @@ func TestBuildsFetch(t *testing.T) {
 		}()
 
 		err := cmdr.BuildsFetch("testapp", 0, procfilePath, dryccpath, "", true)
-		if err == nil || err.Error() != "cancel the build create fetch" {
+		if err == nil || err.Error() != "cancel the build fetch action" {
 			t.Fatalf("expected cancellation error, got %v", err)
 		}
 

From c2a75ca280697b8cada096f0f7d85bf21d6cd2c0 Mon Sep 17 00:00:00 2001
From: lijianguo <lijianguo1991@outlook.com>
Date: Thu, 6 Mar 2025 11:37:08 +0800
Subject: [PATCH 2/3] chore(shortcuts): update shortcuts

---
 cli/cli.go            | 1 +
 cmd/shortcuts_test.go | 1 +
 ps:logs               | 0
 3 files changed, 2 insertions(+)
 create mode 100644 ps:logs

diff --git a/cli/cli.go b/cli/cli.go
index b1bc445c..11274e42 100644
--- a/cli/cli.go
+++ b/cli/cli.go
@@ -4,6 +4,7 @@ package cli
 var Shortcuts = map[string]string{
 	"create":   "apps:create",
 	"destroy":  "apps:destroy",
+	"exec":     "ps:exec",
 	"info":     "apps:info",
 	"login":    "auth:login",
 	"logout":   "auth:logout",
diff --git a/cmd/shortcuts_test.go b/cmd/shortcuts_test.go
index fadf637a..1e17edbf 100644
--- a/cmd/shortcuts_test.go
+++ b/cmd/shortcuts_test.go
@@ -9,6 +9,7 @@ func TestShortcutsList(t *testing.T) {
 
 	expected := `create -> apps:create
 destroy -> apps:destroy
+exec -> ps:exec
 info -> apps:info
 login -> auth:login
 logout -> auth:logout
diff --git a/ps:logs b/ps:logs
new file mode 100644
index 00000000..e69de29b

From 97627bc9a03a3beb839c3d1cadb5ec1acb1649c3 Mon Sep 17 00:00:00 2001
From: lijianguo <lijianguo1991@outlook.com>
Date: Thu, 6 Mar 2025 16:47:21 +0800
Subject: [PATCH 3/3] chore(workflow-cli): upgrade controller-sdk-go

---
 go.mod | 2 +-
 go.sum | 4 ++--
 2 files changed, 3 insertions(+), 3 deletions(-)

diff --git a/go.mod b/go.mod
index 6b1ad53c..12f6f553 100644
--- a/go.mod
+++ b/go.mod
@@ -5,7 +5,7 @@ go 1.23
 require (
 	github.com/containerd/console v1.0.4
 	github.com/docopt/docopt-go v0.0.0-20180111231733-ee0de3bc6815
-	github.com/drycc/controller-sdk-go v0.0.0-20250114084605-55b2a28ae6ee
+	github.com/drycc/controller-sdk-go v0.0.0-20250306084459-f2b9cdd27a9d
 	github.com/drycc/pkg v0.0.0-20241028091700-8caca001c932
 	github.com/minio/selfupdate v0.6.0
 	github.com/olekukonko/tablewriter v0.0.5
diff --git a/go.sum b/go.sum
index e1faaf89..fa277262 100644
--- a/go.sum
+++ b/go.sum
@@ -9,8 +9,8 @@ github.com/davecgh/go-spew v1.1.2-0.20180830191138-d8f796af33cc h1:U9qPSI2PIWSS1
 github.com/davecgh/go-spew v1.1.2-0.20180830191138-d8f796af33cc/go.mod h1:J7Y8YcW2NihsgmVo/mv3lAwl/skON4iLHjSsI+c5H38=
 github.com/docopt/docopt-go v0.0.0-20180111231733-ee0de3bc6815 h1:bWDMxwH3px2JBh6AyO7hdCn/PkvCZXii8TGj7sbtEbQ=
 github.com/docopt/docopt-go v0.0.0-20180111231733-ee0de3bc6815/go.mod h1:WwZ+bS3ebgob9U8Nd0kOddGdZWjyMGR8Wziv+TBNwSE=
-github.com/drycc/controller-sdk-go v0.0.0-20250114084605-55b2a28ae6ee h1:A8uiBnRTW4mY5zKnwku25Rf1YHAAexTAfyMSPiF3uX8=
-github.com/drycc/controller-sdk-go v0.0.0-20250114084605-55b2a28ae6ee/go.mod h1:lGJpGtKDE7WUVJhkxOgWQfd4GEulJ/NlcJycVZIzs5g=
+github.com/drycc/controller-sdk-go v0.0.0-20250306084459-f2b9cdd27a9d h1:KStMQ64DjZ1HeyN6IP2KD0j4nOw/82cdQxQklo5ukhE=
+github.com/drycc/controller-sdk-go v0.0.0-20250306084459-f2b9cdd27a9d/go.mod h1:lGJpGtKDE7WUVJhkxOgWQfd4GEulJ/NlcJycVZIzs5g=
 github.com/drycc/pkg v0.0.0-20241028091700-8caca001c932 h1:tUfkfjmFmlm9n0dYp1NoHcFK6+APD/wHZ2We6CKXDSI=
 github.com/drycc/pkg v0.0.0-20241028091700-8caca001c932/go.mod h1:upGcZF/RCEqidGjSnWHh/txRC1I4GPsRGvF8/+bDfwU=
 github.com/google/go-cmp v0.5.9/go.mod h1:17dUlkBOakJ0+DkrSSNjCkIjxS6bF9zb3elmeNGIjoY=