diff --git a/internal/completion/completion.go b/internal/completion/completion.go
index 7d07a8d6..205471f6 100644
--- a/internal/completion/completion.go
+++ b/internal/completion/completion.go
@@ -357,12 +357,12 @@ func (c *LimitSetPlanCompletion) CompletionFunc(cmd *cobra.Command, args []strin
 			}
 		}
 		return results, cobra.ShellCompDirectiveNoFileComp
-	} else {
-		ptsSetArgsCompletion := PtsSetArgsCompletion{
-			PtsCompletion: &PtsCompletion{AppID: c.AppID, ArgsLen: -1, ConfigFile: c.ConfigFile},
-		}
-		return ptsSetArgsCompletion.CompletionFunc(cmd, args, toComplete)
 	}
+	ptsSetArgsCompletion := PtsSetArgsCompletion{
+		PtsCompletion: &PtsCompletion{AppID: c.AppID, ArgsLen: -1, ConfigFile: c.ConfigFile},
+	}
+	return ptsSetArgsCompletion.CompletionFunc(cmd, args, toComplete)
+
 }
 
 type UserPermsCompletion struct {
@@ -435,12 +435,11 @@ func (c *PermUpdateCompletion) CompletionFunc(cmd *cobra.Command, args []string,
 	if len(args) == 0 {
 		permUsernameCompletion := PermUsernameCompletion{AppID: c.AppID, ArgsLen: 0, ConfigFile: c.ConfigFile}
 		return permUsernameCompletion.CompletionFunc(cmd, args, toComplete)
-	} else {
-		userPermsArgsCompletion := UserPermsArgsCompletion{
-			UserPermsCompletion: &UserPermsCompletion{ConfigFile: c.ConfigFile},
-		}
-		return userPermsArgsCompletion.CompletionFunc(cmd, args, toComplete)
 	}
+	userPermsArgsCompletion := UserPermsArgsCompletion{
+		UserPermsCompletion: &UserPermsCompletion{ConfigFile: c.ConfigFile},
+	}
+	return userPermsArgsCompletion.CompletionFunc(cmd, args, toComplete)
 }
 
 type PsCompletion struct {
@@ -823,12 +822,11 @@ func (c *VolumesMountCompletion) CompletionFunc(cmd *cobra.Command, args []strin
 	if len(args) == 0 {
 		volumeCompletion := VolumeCompletion{AppID: c.AppID, ArgsLen: 0, ConfigFile: c.ConfigFile}
 		return volumeCompletion.CompletionFunc(cmd, args, toComplete)
-	} else {
-		ptsSetArgsCompletion := PtsSetArgsCompletion{
-			PtsCompletion: &PtsCompletion{AppID: c.AppID, ArgsLen: -1, ConfigFile: c.ConfigFile},
-		}
-		return ptsSetArgsCompletion.CompletionFunc(cmd, args, toComplete)
 	}
+	ptsSetArgsCompletion := PtsSetArgsCompletion{
+		PtsCompletion: &PtsCompletion{AppID: c.AppID, ArgsLen: -1, ConfigFile: c.ConfigFile},
+	}
+	return ptsSetArgsCompletion.CompletionFunc(cmd, args, toComplete)
 }
 
 type VolumesUnmountCompletion struct {
diff --git a/internal/parser/autorollback.go b/internal/parser/autorollback.go
index d168b514..d5d809cc 100644
--- a/internal/parser/autorollback.go
+++ b/internal/parser/autorollback.go
@@ -12,7 +12,7 @@ func NewAutorollbackCommand(cmdr *commands.DryccCmd) *cobra.Command {
 	cmd := &cobra.Command{
 		Use:   "autorollback",
 		Short: i18n.T("Manage autorollback if or not for application"),
-		RunE: func(cmd *cobra.Command, args []string) error {
+		RunE: func(_ *cobra.Command, args []string) error {
 			return cmdr.AutorollbackInfo(app)
 		},
 	}
diff --git a/internal/parser/gateways.go b/internal/parser/gateways.go
index 95424dc4..c03a4a40 100644
--- a/internal/parser/gateways.go
+++ b/internal/parser/gateways.go
@@ -12,7 +12,7 @@ func NewGatewaysCommand(cmdr *commands.DryccCmd) *cobra.Command {
 	cmd := &cobra.Command{
 		Use:   "gateways",
 		Short: i18n.T("Manage gateways for your applications"),
-		RunE: func(_ *cobra.Command, args []string) error {
+		RunE: func(_ *cobra.Command, _ []string) error {
 			results, _ := commands.ResponseLimit(limit)
 			return cmdr.GatewaysList(app, results)
 		},
diff --git a/internal/parser/tags.go b/internal/parser/tags.go
index b13b4615..2e047267 100644
--- a/internal/parser/tags.go
+++ b/internal/parser/tags.go
@@ -17,7 +17,7 @@ func NewTagsCommand(cmdr *commands.DryccCmd) *cobra.Command {
 	cmd := &cobra.Command{
 		Use:   "tags",
 		Short: i18n.T("Manage tags for application containers"),
-		RunE: func(cmd *cobra.Command, args []string) error {
+		RunE: func(_ *cobra.Command, args []string) error {
 			return cmdr.TagsList(app, flags.ptype, version)
 		},
 	}
diff --git a/internal/parser/timeouts.go b/internal/parser/timeouts.go
index 03ed230f..68a82ec4 100644
--- a/internal/parser/timeouts.go
+++ b/internal/parser/timeouts.go
@@ -13,7 +13,7 @@ func NewTimeoutsCommand(cmdr *commands.DryccCmd) *cobra.Command {
 	cmd := &cobra.Command{
 		Use:   "timeouts",
 		Short: i18n.T("Manage pods termination grace period"),
-		RunE: func(_ *cobra.Command, args []string) error {
+		RunE: func(_ *cobra.Command, _ []string) error {
 			return cmdr.TimeoutsList(app, version)
 		},
 	}
diff --git a/internal/parser/tls.go b/internal/parser/tls.go
index b01b5de6..ec4f4b8b 100644
--- a/internal/parser/tls.go
+++ b/internal/parser/tls.go
@@ -15,7 +15,7 @@ func NewTLSCommand(cmdr *commands.DryccCmd) *cobra.Command {
 	cmd := &cobra.Command{
 		Use:   "tls",
 		Short: i18n.T("Manage TLS/SSL settings for applications"),
-		RunE: func(cmd *cobra.Command, args []string) error {
+		RunE: func(_ *cobra.Command, args []string) error {
 			return cmdr.TLSInfo(app)
 		},
 	}
diff --git a/internal/parser/version.go b/internal/parser/version.go
index 8512246d..5654f891 100644
--- a/internal/parser/version.go
+++ b/internal/parser/version.go
@@ -15,7 +15,7 @@ func NewVersionCommand(cmdr *commands.DryccCmd) *cobra.Command {
 		Use:   "version",
 		Short: i18n.T("Display client version"),
 		Long:  i18n.T("Displays the client version"),
-		Run: func(_ *cobra.Command, args []string) {
+		Run: func(_ *cobra.Command, _ []string) {
 			cmdr.Version(flags.all)
 		},
 	}
diff --git a/pkg/settings/utils_test.go b/pkg/settings/utils_test.go
index 4081b729..ea923ded 100644
--- a/pkg/settings/utils_test.go
+++ b/pkg/settings/utils_test.go
@@ -15,6 +15,8 @@ type confgCases struct {
 
 func TestSelectSettings(t *testing.T) {
 	t.Parallel()
+	homeDir := "/a/b/c"
+	SetHome(homeDir)
 	cases := []confgCases{
 		{"test", filepath.Join(FindHome(), ".drycc", "test.json")},
 		{"", filepath.Join(FindHome(), ".drycc", "client.json")},